;----------------------------------------------------
;- Object:  GDIPLUS.DLL 1.0 WRAPPER for PureBasic 4.0
;- Author:  flype, jul 2006.
;- Support: http://msdn.microsoft.com/library/default.asp?url=/library/en-us/gdicpp/GDIPlus/GDIPlusreference.asp
;----------------------------------------------------

EnableExplicit

;- FUNCTIONS

Import "gdiplus.lib" ;{
  
  ; init
  GdiplusStartup(*token, *input, *output) 
  GdiplusShutdown(*token)
  GdipAlloc(size.l)
  GdipFree(*ptr)
  
  ; codec
  GdipGetImageEncodersSize(*numDecoders, *size)
  GdipGetImageDecodersSize(*numDecoders, *size)
  GdipGetImageEncoders(numDecoders.l, size.l, *decoders)
  GdipGetImageDecoders(numDecoders.l, size.l, *decoders)
  
  ; image
  GdipDisposeImage(*image)
  GdipGetImageWidth(*image, *width)
  GdipGetImageHeight(*image, *height)
  GdipImageRotateFlip(*image, type.l)
  GdipSaveAddImage(*image, *newImage, encoderParams.l)
  GdipSaveImageToFile(*image, filename.p-unicode, *clsidEncoder, encoderParams.l)
  GdipImageGetFrameCount(*image, *guid, *count)
  GdipImageSelectActiveFrame(*image, *dimensionID, frameIndex.l)
  GdipCreateImageAttributes(*imageAttributes)
  GdipDisposeImageAttributes(*imageAttributes)
  GdipSetImageAttributesColorMatrix(*imageAttributes, type.l, enableFlag, *colorMatrix, *grayMatrix, flags.l)
  GdipCreateBitmapFromFile(filename.p-unicode, *image)
  
  ; graphic
  GdipCreateFromHDC(*deviceContext, *graphics) 
  GdipCreateFromHWND(*window, *graphics) 
  GdipDeleteGraphics(*graphics)
  GdipGraphicsClear(*graphics, color.l)
  GdipSetSmoothingMode(*graphics, mode.l) 
  GdipDrawArc(*graphics, *pen, x.f, y.f, w.f, h.f, startAngle.f, sweepAngle.f)
  GdipDrawArcI(*graphics, *pen, x.l, y.l, w.l, h.l, startAngle.f, sweepAngle.f)
  GdipDrawLine(*graphics, *pen, x1.f, y1.f, x2.f, y2.f)
  GdipDrawLineI(*graphics, *pen, x1.l, y1.l, x2.l, y2.l)
  GdipDrawBezier(*graphics, *pen, x1.f, y1.f, x2.f, y2.f, x3.f, y3.f, x4.f, y4.f) 
  GdipDrawBezierI(*graphics, *pen, x1.l, y1.l, x2.l, y2.l, x3.l, y3.l, x4.l, y4.l)
  GdipDrawEllipse(*graphics, *pen, x.f, y.f, w.f, h.f)
  GdipDrawEllipseI(*graphics, *pen, x.l, y.l, w.l, h.l)
  GdipDrawImage(*graphics, *image, x.f, y.f)
  GdipDrawImageI(*graphics, *image, x.l, y.l)
  GdipDrawImageRect(*graphics, *image, x.f, y.f, w.f, h.f)
  GdipDrawImageRectI(*graphics, *image, x.l, y.l, w.l, h.l)
  GdipDrawImageRectRect(*graphics, *image, dstx.f, dsty.f, dstw.f, dsth.f, scrx.f, srcy.f, srcw.f, srch.f, srcUnit.l, *imageAttributes, *callback, *callbackData)
  GdipDrawImageRectRectI(*graphics, *image, dstx.l, dsty.l, dstw.l, dsth.l, scrx.l, srcy.l, srcw.l, srch.l, srcUnit.l, *imageAttributes, *callback, *callbackData)
  GdipDrawRectangle(*graphics, *pen, x.f, y.f, w.f, h.f)
  GdipDrawRectangleI(*graphics, *pen, x.l, y.l, w.l, h.l)
  GdipFillEllipse(*graphics, *brush, x.f, y.f, w.f, h.f)
  GdipFillEllipseI(*graphics, *brush, x.l, y.l, w.l, h.l)
  GdipFillRectangle(*graphics, *brush, x.f, y.f, w.f, h.f)
  GdipFillRectangleI(*graphics, *brush, x.l, y.l, w.l, h.l)
  GdipResetWorldTransform(*graphics)
  GdipRotateWorldTransform(*graphics, angle.f, order.l)
  GdipTranslateWorldTransform(*graphics, dx.f, dy.f, order.l)
  GdipDrawString(*graphics, string.p-unicode, length.l, *font, *layoutRect, *stringFormat, *brush)
  
  ; texture
  GdipCreateTexture(*image, wrapMode.l, *texture)
  
  ; font
  GdipCreateFont(*fontFamily, emSize.f, style.l, unit.l, *font)
  GdipCreateFontFamilyFromName(fontName.p-unicode, *fontCollection, *fontFamily)
  GdipDeleteFontFamily(*fontFamily)
  GdipDeleteFont(*font)
  
  ; brush
  GdipDeleteBrush(*brush)
  GdipGetBrushType(*brush, type.l)
  GdipCreateSolidFill(color.l, *brush)
  GdipCreateLineBrushI(*point1, *point2, fgCol.l, bgCol.l, wrapMode.l, *lineGradient)
  GdipCreateHatchBrush(hatchStyle.l, fgCol.l, bgCol.l, *brush)
  GdipCreatePathGradient(*points, count.l, wrapMode.l, *polyGradient)
  GdipCreatePathGradientI(*points, count.l, wrapMode.l, *polyGradient)
  GdipSetPathGradientCenterColor(*brush, color.l)
  GdipSetLinePresetBlend(*brush, *blend, *positions, count.l)
  
  ; pen
  GdipCreatePen1(color.l, width.f, unit.l, *Pen) 
  GdipCreatePen2(brush.l, width.f, unit.l, *Pen) 
  GdipSetPenStartCap(*pen, customCap.l) 
  GdipSetPenEndCap(*pen, customCap.l) 
  GdipDeletePen(*pen) 
  
EndImport ;}

;- STRUCTURES

Prototype.l NotificationHookProc(*token)
Prototype.l NotificationUnhookProc(*token)
Prototype.l DebugEventProc(level.l, message.p-unicode)

Structure RectF ;{
  left.f 
  top.f 
  width.f 
  height.f 
EndStructure ;}
Structure PointF ;{
  x.f 
  y.f 
EndStructure ;}
Structure ColorMatF ;{
  a.f
  b.f
  c.f
  d.f
  e.f
EndStructure ;}
Structure ColorMatrix ;{
  a.ColorMatF
  b.ColorMatF
  c.ColorMatF
  d.ColorMatF
  e.ColorMatF
EndStructure ;}
Structure ImageCodecInfo ;{
  clsid.CLSID
  formatID.GUID
  codecName.s
  dllName.s
  formatDescription.s
  filenameExtension.s
  mimeType.s
  flags.l
  version.l
  sigCount.l
  sigSize.l
  *sigPattern
  *sigMask
EndStructure ;}
Structure GdiplusStartupInput ;{
  GdiPlusVersion.l 
  *DebugEventCallback.DebugEventProc
  SuppressBackgroundThread.l 
  SuppressExternalCodecs.l 
EndStructure ;}
Structure GdiplusStartupOutput ;{
  *NotificationHook.NotificationHookProc
  *NotificationUnhook.NotificationUnhookProc
EndStructure ;}
Structure EncoderParameter ;{
  count.l
  guid.GUID
  numberOfValues.l
  type.l
  *value
EndStructure ;}

;- CONSTANTS

Enumeration  0 ;{ BrushType
  #BrushTypeSolidColor
  #BrushTypeHatchFill
  #BrushTypeTextureFill
  #BrushTypePathGradient
  #BrushTypeLinearGradient
EndEnumeration ;}
Enumeration  0 ;{ ColorAdjustType
  #ColorAdjustTypeDefault
  #ColorAdjustTypeBitmap
  #ColorAdjustTypeBrush
  #ColorAdjustTypePen
  #ColorAdjustTypeText
  #ColorAdjustTypeCount
  #ColorAdjustTypeAny
EndEnumeration ;}
Enumeration  0 ;{ Units
  #UnitWorld      ; World coordinate (non-physical unit).
  #UnitDisplay    ; For PageTransform only.
  #UnitPixel      ; Each unit is one device pixel.
  #UnitPoint      ; Each unit is a printer's point, or 1/72 inch.
  #UnitInch       ; Each unit is 1 inch.
  #UnitDocument   ; Each unit is 1/300 inch.
  #UnitMillimeter ; Each unit is 1 millimeter.
EndEnumeration ;}
Enumeration  0 ;{ LineCap
  #LineCapFlat
  #LineCapSquare
  #LineCapRound
  #LineCapTriangle
  #LineCapNoAnchor = $10
  #LineCapSquareAnchor
  #LineCapRoundAnchor
  #LineCapDiamondAnchor
  #LineCapArrowAnchor
  #LineCapCustom = $FF
  #LineCapAnchorMask = $F0
EndEnumeration ;}
Enumeration  0 ;{ WrapMode
  #WrapModeTile
  #WrapModeTileFlipX
  #WrapModeTileFlipY
  #WrapModeTileFlipXY
  #WrapModeClamp
EndEnumeration ;}
Enumeration -1 ;{ QualityMode
  #QualityModeInvalid
  #QualityModeDefault
  #QualityModeLow
  #QualityModeHigh
EndEnumeration ;}
Enumeration -1 ;{ SmoothingMode
  #SmoothingModeInvalid
  #SmoothingModeDefault
  #SmoothingModeHighSpeed
  #SmoothingModeHighQuality
  #SmoothingModeNone
  #SmoothingModeAntiAlias
EndEnumeration ;}
Enumeration  0 ;{ EncoderParameters
  #EncoderValueColorTypeCMYK
  #EncoderValueColorTypeYCCK
  #EncoderValueCompressionLZW
  #EncoderValueCompressionCCITT3
  #EncoderValueCompressionCCITT4
  #EncoderValueCompressionRle
  #EncoderValueCompressionNone
  #EncoderValueScanMethodInterlaced
  #EncoderValueScanMethodNonInterlaced 
  #EncoderValueVersionGif87
  #EncoderValueVersionGif89
  #EncoderValueRenderProgressive
  #EncoderValueRenderNonProgressive
  #EncoderValueTransformRotate90
  #EncoderValueTransformRotate180
  #EncoderValueTransformRotate270
  #EncoderValueTransformFlipHorizontal
  #EncoderValueTransformFlipVertical   
  #EncoderValueMultiFrame
  #EncoderValueLastFrame
  #EncoderValueFlush
  #EncoderValueFrameDimensionTime
  #EncoderValueFrameDimensionResolution
  #EncoderValueFrameDimensionPage
EndEnumeration ;}
Enumeration  0 ;{ RotateFlipTypes
  #RotateNoneFlipNone
  #Rotate90FlipNone
  #Rotate180FlipNone
  #Rotate270FlipNone
  #RotateNoneFlipX
  #Rotate90FlipX
  #Rotate180FlipX
  #Rotate270FlipX
EndEnumeration ;}
Enumeration  0 ;{ FontStyle
  #FontStyleRegular
  #FontStyleBold
  #FontStyleItalic
  #FontStyleBoldItalic
  #FontStyleUnderline
  #FontStyleStrikeout = 8
EndEnumeration ;}

;- MACROS

Macro WCHAR(unicode)
  PeekS(@unicode, -1, #PB_Unicode)
EndMacro
Macro MAKECOLOR(a,r,g,b)
  ((b)|(g)<<8|(r)<<16|(a)<<24)
EndMacro

;- PROCEDURES

ProcedureDLL.l DebugEventProc(*level, message.s)
  Debug "GDIPlus.DebugEventProc()"
  Debug *level
  Debug message
EndProcedure

ProcedureDLL.l ARGB(rgb.l, a.b = 255) ; $00RRGGBB --> $AABBGGRR
  !MOV eax, [p.v_rgb]
  !BSWAP eax 
  !SHR eax, 8 
  !MOV [p.v_rgb], eax 
  !MOV eax, [p.v_a]
  !MOV dword [p.v_rgb+3], eax
  ProcedureReturn rgb
EndProcedure
ProcedureDLL.l ABGR(bgr.l, a.b = 255) ; $00BBGGRR --> $AABBGGRR
  !MOV eax, [p.v_a]
  !MOV dword [p.v_bgr+3], eax
  ProcedureReturn bgr
EndProcedure

ProcedureDLL.l SetRectF(*r.RectF, x.f, y.f, w.f, h.f)
  *r\left   = x
  *r\top    = y 
  *r\width  = w
  *r\height = h
  ProcedureReturn *r
EndProcedure

ProcedureDLL.l Gdiplus_New(version.l = 1, *hEventCB = #Null, Codecs.l = #False, bgThread.l = #False)
  Protected *token, input.GdiplusStartupInput
  input\GdiPlusVersion = version
  input\DebugEventCallback = *hEventCB
  input\SuppressExternalCodecs = Codecs
  input\SuppressBackgroundThread = bgThread
  GdiplusStartup(@*token, @input, #Null)
  ProcedureReturn *token
EndProcedure
ProcedureDLL.l Gdiplus_Del(*token)
  GdiplusShutdown(*token)
EndProcedure

ProcedureDLL.l Gdiplus_StartDrawing(*PBOutput, smooth.l = 0)
  Shared *graphics
  Protected *hDC = StartDrawing(*PBOutput) 
  GdipCreateFromHDC(*hDC, @*graphics)
  GdipSetSmoothingMode(*graphics, smooth)
  ProcedureReturn *graphics
EndProcedure
ProcedureDLL.l Gdiplus_StopDrawing()
  Shared *graphics
  GdipDeleteGraphics(*graphics) 
  StopDrawing()
EndProcedure

ProcedureDLL.l Gdiplus_String(string.s, x.l, y.l, w.l, h.l, fntName.s, fntSize.f, fntStyle.l, color1.l, color2.l) 
  Shared *graphics
  Protected *family, *font, *brush, layout.RectF
  GdipCreateFontFamilyFromName(fntName, #Null, @*family) 
  GdipCreateFont(*family, fntSize, fntStyle, 2, @*font) 
  GdipCreateHatchBrush(20, color1, color2, @*brush)
  SetRectF(layout, x, y, w, h)
  GdipDrawString(*graphics, string, -1, *font, layout, #Null, *brush) 
  GdipDeleteFontFamily(*family) 
  GdipDeleteFont(*font) 
  GdipDeleteBrush(*brush) 
EndProcedure 

ProcedureDLL.l Gdiplus_Cls(color.l = $FF000000)
  Shared *graphics
  GdipGraphicsClear(*graphics, color)
EndProcedure
ProcedureDLL.l Gdiplus_Line(x1.l, y1.l, x2.l, y2.l, w.f, color.l, cap1.l, cap2.l) 
  Shared *graphics
  Protected *pen
  GdipCreatePen1(color, w, 2, @*pen) 
  GdipSetPenStartCap(*pen, cap1) 
  GdipSetPenEndCap(*pen, cap2) 
  GdipDrawLineI(*graphics, *pen, x1, y1, x2, y2) 
  GdipDeletePen(*pen) 
EndProcedure
ProcedureDLL.l Gdiplus_Bezier(x1.f, y1.f, x2.f, y2.f, x3.f, y3.f, x4.f, y4.f, w.f, color.l, cap1.l, cap2.l) 
  Shared *graphics
  Protected *pen
  GdipCreatePen1(color, w, 2, @*Pen) 
  GdipSetPenStartCap(*pen, cap1) 
  GdipSetPenEndCap(*pen, cap2) 
  GdipDrawBezier(*graphics, *pen, x1, y1, x2, y2, x3, y3, x4, y4)
  GdipDeletePen(*pen) 
EndProcedure
ProcedureDLL.l Gdiplus_Ellipse(x.l, y.l, w.l, h.l, color.l) 
  Shared *graphics
  Protected *pen
  GdipCreatePen1(color, w, 0, @*pen) 
  GdipDrawEllipseI(*graphics, *pen, x, y, w, h)
  GdipDeletePen(*pen) 
EndProcedure

;- END OF FILE

DisableExplicit

; IDE Options = PureBasic v4.00 (Windows - x86)
; CursorPosition = 103
; FirstLine = 16
; Folding = AAAAAw
; DisableDebugger